{---------------------------------------------------------------}
{
{    EASY BOARD - Editor and Presenter of
{                    Boards for alternative communication
{
{    Module: Configuration of Execution
{
{    Authors: Jos Antonio Borges     (NCE/UFRJ)
{             Miryam Bonadiu Pelosi    (LabAssistiva/UFRJ)
{             Julio Tadeu da Silveira  (NCE/UFRJ)
{
{    Version 1.1 in april/2015
{
{----------------------------------------------------------------}

unit prConfigExec;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TFormConfigExec = class(TForm)
    b_ok: TButton;
    cb_falando: TCheckBox;
    cb_sintetNaoGrav: TCheckBox;
    Label1: TLabel;
    Label6: TLabel;
    c_pranchaInicial: TComboBox;
    c_pranchaSocorro: TComboBox;
    Panel1: TPanel;
    Label3: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    e_socorro: TEdit;
    e_histerese: TEdit;
    e_varredura: TEdit;
    ms: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label8: TLabel;
    e_autoClique: TEdit;
    Label9: TLabel;
    b_sint: TButton;
    cb_falaVarredura: TCheckBox;
    cb_acionaTobii: TCheckBox;
    procedure b_okClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure b_sintClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormConfigExec: TFormConfigExec;

implementation

uses prVars;

{$R *.dfm}

procedure TFormConfigExec.b_okClick(Sender: TObject);
var erro: boolean;
begin
    with projeto do
        begin
            falaAutomatica := cb_falando.Checked;
            falaVarredura := cb_falaVarredura.Checked;
            SintetNaoGravados := cb_sintetNaoGrav.Checked;
            acionaTobii := cb_acionaTobii.Checked;

            pranchaInicial := c_pranchaInicial.Text;
            pranchaSocorro := c_pranchaSocorro.Text;

            try
                tempoVarredura  := strToInt(trim(e_varredura.Text));
                tempoHisterese  := strToInt(trim(e_histerese.Text));
                tempoSocorro    := strToInt(trim(e_socorro.Text));
                tempoAutoClique := strToInt(trim(e_autoClique.Text));

                erro := false;
                if (tempoVarredura <> 0) and (tempoVarredura < 500) then
                    begin
                        tempoVarredura := 2000;
                        erro := true;
                    end;

                if (tempoHisterese <> 0) and (tempoHisterese < 200) then
                    begin
                        tempoHisterese := 1000;
                        erro := true;
                    end;

                if (tempoSocorro <> 0) and (tempoSocorro <= tempoVarredura+500) then
                    begin
                        tempoSocorro := tempoVarredura+1000;
                        erro := true;
                    end;

                if (tempoAutoClique <> 0) and (tempoVarredura <> 0) then
                    begin
                        tempoAutoClique := 0;
                        erro := true;
                    end;

                if erro then
                       begin
                           showMessage ('inconsistent times: moved to consistent values (ms)');
                           e_varredura.Text  := intToStr (tempoVarredura);
                           e_histerese.Text  := intToStr (tempoHisterese);
                           e_socorro.Text    := intToStr (tempoSocorro);
                           e_autoClique.Text := intToStr (tempoAutoClique);
                           exit;
                       end;

                close;
            except
                showMessage ('Invalid numerical data, check it');
            end;
        end;
end;

procedure TFormConfigExec.FormActivate(Sender: TObject);
var i: integer;
begin
    with projeto do
        begin
            cb_sintetNaoGrav.Checked := SintetNaoGravados;
            cb_falaVarredura.Checked := falaVarredura;
            cb_falando.Checked := falaAutomatica;
            cb_acionaTobii.Checked := acionaTobii;

            e_varredura.Text   := intToStr(tempoVarredura);
            e_histerese.Text   := intToStr(tempoHisterese);
            e_socorro.Text     := intToStr(tempoSocorro);
            e_autoClique.Text  := intToStr(tempoAutoClique);

            c_pranchaInicial.Clear;
            for i := 0 to nPranchas-1 do
                c_pranchaInicial.items.add (pranchas[i].nome);
            c_pranchaInicial.Text := pranchaInicial;
            c_pranchaSocorro.Clear;
            for i := 0 to nPranchas-1 do
                c_pranchaSocorro.items.add (pranchas[i].nome);
            c_pranchaSocorro.Text := pranchaSocorro;
        end;
end;

procedure TFormConfigExec.b_sintClick(Sender: TObject);
begin
    winExec ('cmd /c %SystemRoot%\System32\Speech\SpeechUX\sapi.cpl', SW_SHOWNORMAL);
end;

end.

