{---------------------------------------------------------------}
{
{    Easy Board - Editor and Presenter of
{                 Boards for alternative communication
{
{    Selection Module of initial board for execution
{
{    Authors: Jos Antonio Borges     (NCE/UFRJ)
{             Miryam Bonadiu Pelosi    (LabAssistiva/UFRJ)
{             Julio Tadeu da Silveira  (NCE/UFRJ)
{
{    Version 1.1: april/2015
{
{----------------------------------------------------------------}

unit prConfigItem;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, jpeg, ExtCtrls, Buttons, MPlayer, Spin;

type
  TformConfigItem = class(TForm)
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    e_executar: TEdit;
    Label15: TLabel;
    b_importarFigura: TButton;
    b_escolher: TButton;
    b_ok: TButton;
    Shape1: TShape;
    Label7: TLabel;
    ColorDialog1: TColorDialog;
    b_importarSom: TButton;
    combo_link: TComboBox;
    combo_figura: TComboBox;
    combo_som: TComboBox;
    OpenDialog1: TOpenDialog;
    b_biblioteca: TButton;
    p_item: TPanel;
    r_letras: TRadioGroup;
    r_postexto: TRadioGroup;
    r_margem: TRadioGroup;
    Label1: TLabel;
    e_rotulo: TEdit;
    cb_desloca: TCheckBox;
    b_play: TBitBtn;
    b_stop: TBitBtn;
    b_rec: TBitBtn;
    cb_semRotulo: TCheckBox;
    cb_semFigura: TCheckBox;
    b_playFala: TBitBtn;
    b_stopFala: TBitBtn;
    b_recFala: TBitBtn;
    combo_fala: TComboBox;
    e_tamLetras: TEdit;
    procedure b_okClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure b_importarFiguraClick(Sender: TObject);
    procedure b_importarSomClick(Sender: TObject);
    procedure b_escolherClick(Sender: TObject);
    procedure b_bibliotecaClick(Sender: TObject);
    procedure Shape1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure combo_figuraChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure redesenha(Sender: TObject);
    procedure MediaPlayer1Click(Sender: TObject; Button: TMPBtnType;
      var DoDefault: Boolean);
    procedure b_playClick(Sender: TObject);
    procedure cb_semFiguraClick(Sender: TObject);
    procedure b_stopClick(Sender: TObject);
    procedure b_recClick(Sender: TObject);
    procedure e_rotuloChange(Sender: TObject);
    procedure cb_semRotuloClick(Sender: TObject);
    procedure b_playFalaClick(Sender: TObject);
    procedure b_recFalaClick(Sender: TObject);
    procedure b_stopFalaClick(Sender: TObject);
    procedure r_letrasClick(Sender: TObject);
    procedure e_tamLetrasChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure setInfo (indPrancha, ind: integer);
    procedure getInfo (indPrancha, ind: integer);
    procedure recarregaCombos(Sender: TObject);
    procedure desenhaItem;
  end;

var
  formConfigItem: TformConfigItem;

implementation

{$R *.dfm}
uses prVars, prArq, prSelFigura, prGraficos, prGravador, prMci;

var
    itemGraf: TItemGraf;
    montando: boolean;


function tamLetraValida (s: string): integer;
var i, erro: integer;
begin
    val (s, i, erro);
    if (erro = 0) and (i >= TAM_MIN_FONTE) and (i <= TAM_MAX_FONTE) then
        result := i
    else
        result := TAM_MIN_FONTE;
end;

procedure TformConfigItem.setInfo (indPrancha, ind: integer);
begin
    if indPrancha < 0 then exit;
    if ind < 0 then exit;

    montando := true;
    with projeto.pranchas[indPrancha].itens[ind] do
        begin
            e_rotulo.Text := rotulo;
            combo_figura.Text := figura;
            combo_fala.Text := fala;
            combo_som.Text := som;
            combo_link.Text := link;
            e_executar.Text := executar;
            shape1.Brush.Color := cor;

            cb_semRotulo.Checked := semRotulo;
            cb_semFigura.Checked := semFigura;
            r_postexto.ItemIndex := ord(posTexto);
            r_letras.ItemIndex := 3;
            e_tamLetras.text := intToStr(dimTexto);
            r_margem.ItemIndex := ord(dimMoldura);
            cb_desloca.Checked := deslocHoriz;
        end;
    montando := false;
end;

procedure TformConfigItem.getInfo (indPrancha, ind: integer);
begin
    if indPrancha < 0 then exit;
    if ind < 0 then exit;

    with projeto.pranchas[indPrancha].itens[ind] do
        begin
            rotulo := e_rotulo.Text;
            figura := combo_figura.Text;
            fala := combo_fala.Text;
            som := combo_som.Text;
            link := combo_link.Text;
            executar := e_executar.Text;
            cor := shape1.Brush.Color;

            semRotulo := cb_semRotulo.Checked;
            semFigura := cb_semFigura.Checked;
            posTexto := TPosVertical(r_postexto.ItemIndex);
            dimTexto := tamLetraValida(e_tamLetras.text);
            dimMoldura := TDimMoldura(r_margem.ItemIndex);
            deslocHoriz := cb_desloca.Checked;
        end;
end;

procedure TFormConfigItem.desenhaItem;
var bbox: TRect;
    umaFigura: string;
begin
    destroiItemGraf (itemGraf);
    bbox.Left := 0;
    bbox.Top := 0;
    bbox.Right := p_item.Width-1;
    bbox.Bottom := p_item.Height-1;

    umaFigura := combo_figura.Text;
    if cb_semFigura.Checked then
        umaFigura := ''
    else
        begin
            if umaFigura = '' then
                if FileExists(e_rotulo.Text + '.jpg') then
                     umaFigura := e_rotulo.Text + '.jpg';
            if lowerCase (ExtractFileExt(umaFigura)) <> '.jpg' then
                     umaFigura := umaFigura + '.jpg';
            if not FileExists (umaFigura) then
                umaFigura := ExtractFilePath(ParamStr(0))+'_figvazia.jpg';
        end;

    criaItemGraf (itemGraf, bbox, umaFigura, cb_semFigura.checked,
                             e_rotulo.Text, cb_semRotulo.Checked,
                             TPosVertical(r_postexto.ItemIndex),
                             tamLetraValida(e_tamLetras.text),
                             shape1.Brush.Color,
                             tDimMoldura(r_margem.itemIndex), p_item);
end;

procedure TformConfigItem.b_okClick(Sender: TObject);
begin
    destroiItemGraf(itemGraf);
    close;
end;

procedure TformConfigItem.recarregaCombos(Sender: TObject);
begin
    combo_figura.Items.Clear;
    combo_figura.Sorted := false;
    adicionaArquivos (combo_figura.items, 'jpg');
    adicionaArquivos (combo_figura.items, 'bmp');
    combo_figura.Sorted := true;

    combo_som.Items.Clear;
    combo_som.Sorted := false;
    adicionaArquivos (combo_som.items, 'mp3');
    adicionaArquivos (combo_som.items, 'wav');
    combo_som.Sorted := true;
    combo_fala.Items.Assign(combo_som.Items);
end;

procedure TformConfigItem.FormActivate(Sender: TObject);
var p: integer;

begin
    recarregaCombos(Sender);

    combo_link.items.Clear;
    for p := 0 to projeto.nPranchas-1 do
        combo_link.Items.add (projeto.pranchas[p].nome);

    desenhaItem;
end;

procedure TformConfigItem.b_importarFiguraClick(Sender: TObject);
var nomeArqFig: string;
begin
    openDialog1.InitialDir := dirProjeto;
    openDialog1.Filter := '*.jpg|*.jpg|*.bmp|*.bmp|*.*|*.*';
    if openDialog1.Execute then
        begin
            nomeArqFig := ExtractFileName(openDialog1.FileName);
            combo_figura.Text := nomeArqFig;
            copyFile (pchar(openDialog1.FileName), pchar(dirProjeto+'\'+nomeArqFig), false);
        end;

    chdir (dirProjeto);
    desenhaItem;
end;

procedure TformConfigItem.b_importarSomClick(Sender: TObject);
var nomeSom: string;
begin
    openDialog1.InitialDir := dirProjeto;
    openDialog1.Filter := '*.mp3|*.mp3|*.wav|*.wav|*.*|*.*';
    if openDialog1.Execute then
        begin
            nomeSom := ExtractFileName(openDialog1.FileName);
            combo_som.Text := nomeSom;
            try
                copyFile (pchar(openDialog1.FileName), pchar(dirProjeto+'\'+nomeSom), false);
            except
                showMessage ('Could not copy');
            end;
        end;

    chdir (dirProjeto);
end;

procedure TformConfigItem.b_escolherClick(Sender: TObject);
var arq, dir: string;
begin
    openDialog1.InitialDir := dirProjeto;
    openDialog1.Filter := 'Executables or videos|*.exe;*.mp4|*.*|*.*';
    if openDialog1.Execute then
        begin
             arq := openDialog1.FileName;
             dir := ExtractFileDir(arq);
             if dir = dirProjeto then
                 arq := ExtractFileName(arq);
             e_executar.Text := arq;
        end;

    chdir (dirProjeto);
end;

procedure TformConfigItem.b_bibliotecaClick(Sender: TObject);
begin
    formSelFigura.showModal;
    combo_figura.Clear;
    combo_figura.Text := prSelFigura.figuraImportada;
    adicionaArquivos (combo_figura.items, 'jpg');

    chdir (dirProjeto);
    desenhaItem;
end;

procedure TformConfigItem.Shape1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    if ColorDialog1.Execute then
         begin
             shape1.Brush.Color := ColorDialog1.Color;
             desenhaItem;
         end;
end;

procedure TformConfigItem.combo_figuraChange(Sender: TObject);
begin
    desenhaItem;
end;

procedure TformConfigItem.redesenha(Sender: TObject);
begin
    destroiItemGraf (itemGraf);
    desenhaItem;
end;

procedure TformConfigItem.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
    destroiItemGraf(itemGraf);
    prMci.terminaMidia;
end;

procedure TformConfigItem.MediaPlayer1Click(Sender: TObject;
          Button: TMPBtnType; var DoDefault: Boolean);
begin
    showMessage ('Was asked ' + intToStr (ord(button)));
end;

procedure TformConfigItem.cb_semFiguraClick(Sender: TObject);
begin
    combo_figura.Enabled := not cb_semFigura.Checked;
    desenhaItem;
end;

procedure TformConfigItem.b_playClick(Sender: TObject);
var nomeSom: string;
begin
    nomeSom := combo_som.text;
    prMci.iniciaMidia(nomeSom, false);
end;

procedure TformConfigItem.b_stopClick(Sender: TObject);
begin
    prMci.terminaMidia;
end;

procedure TformConfigItem.b_recClick(Sender: TObject);
var
    nomeSom: string;
begin
    prMci.terminaMidia;
    nomeSom := combo_som.text;
    if formGravador.checaSom (nomeSom) then
        begin
            formGravador.combo_nomeArq.text := nomeSom;
            formGravador.showModal;
        end;

    recarregaCombos (Sender);
end;

procedure TformConfigItem.e_rotuloChange(Sender: TObject);
begin
    if not montando then
        desenhaItem;
end;

procedure TformConfigItem.cb_semRotuloClick(Sender: TObject);
begin
    if not montando then
        desenhaItem;
end;

procedure TformConfigItem.b_playFalaClick(Sender: TObject);
var nomeSom: string;
begin
    nomeSom := combo_fala.text;
    prMci.iniciaMidia(nomeSom, false);
end;

procedure TformConfigItem.b_recFalaClick(Sender: TObject);
var
    nomeSom: string;
begin
    prMci.terminaMidia;

    nomeSom := combo_fala.text;
    if formGravador.checaSom (nomeSom) then
        begin
            formGravador.combo_nomeArq.text := nomeSom;
            formGravador.showModal;
        end;

    recarregaCombos (Sender);
end;

procedure TformConfigItem.b_stopFalaClick(Sender: TObject);
begin
    prMci.terminaMidia;
end;

procedure TformConfigItem.r_letrasClick(Sender: TObject);
begin
    case r_letras.ItemIndex of
        0:   e_tamLetras.text := intToStr(TEXTO_PEQUENO);
        1:   e_tamLetras.text := intToStr(TEXTO_MEDIO);
        2:   e_tamLetras.text := intToStr(TEXTO_GRANDE);
    end;

    if r_letras.ItemIndex <> 3 then
        begin
            e_tamLetrasChange(Sender);
            if not montando then
                redesenha (Sender);
        end;
end;

procedure TformConfigItem.e_tamLetrasChange(Sender: TObject);
begin
    case tamLetraValida(e_tamLetras.text) of
        TEXTO_PEQUENO:
              if r_letras.ItemIndex <> 0 then  r_letras.ItemIndex := 0;
        TEXTO_MEDIO:
              if r_letras.ItemIndex <> 1 then  r_letras.ItemIndex := 1;
        TEXTO_GRANDE:
              if r_letras.ItemIndex <> 2 then  r_letras.ItemIndex := 2;
    else
        begin
            if r_letras.ItemIndex <> 3 then
                r_letras.ItemIndex := 3;
            if not montando then
                redesenha (Sender);
        end;
    end;
end;

end.

