{---------------------------------------------------------------}
{
{    EASY BOARD - Editor and presenter of
{                 Boards for alternative communication
{
{    Module: Printing
{
{    Authors: Jos Antonio Borges     (NCE/UFRJ)
{             Miryam Bonadiu Pelosi    (LabAssistiva/UFRJ)
{             Julio Tadeu da Silveira  (NCE/UFRJ)
{
{    Version 1.1 in april/2015
{
{----------------------------------------------------------------}

unit prImprime;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, printers;

type
  TFormImprime = class(TForm)
    Panel1: TPanel;
    Timer1: TTimer;
    PrintDialog1: TPrintDialog;
    procedure FormActivate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormImprime: TFormImprime;

implementation

{$R *.dfm}
uses prVars, prGraficos, prSelImprime;

var
    pranchaImprime: TPranchaGraf;

procedure TFormImprime.FormActivate(Sender: TObject);
begin
    if not PrintDialog1.Execute then exit;

    panel1.Caption := 'Preparing printing';
    Screen.Cursor := crHourGlass;
    panel1.Width := clientWidth;
    panel1.Height := clientHeight;

    timer1.enabled := true;
end;

procedure TFormImprime.Timer1Timer(Sender: TObject);
var i: integer;
    bmp: TBitMap;
    x, y, WDPI, HDPI: Integer;
    tit: string;
    ultSel: integer;
begin
    timer1.enabled := false;

    with Printer do
        begin
            Title := 'Easy Board';
            Orientation := poLandscape;
            BeginDoc;

            HDPI := PageHeight div 8;
            WDPI := PageWidth div 8;
            x := PageWidth - Round(WDPI * 0.4); {0.4" margem direita}
            y := PageHeight - Round(HDPI * 0.5); {0.5" Altura do rodap}
        end;

    ultSel := -1;
    for i := 0 to projeto.nPranchas-1 do
        if FormSelImprime.lb_pranchas.Selected[i] then
            ultSel := i;

    panel1.Caption := '';

    for i := 0 to projeto.nPranchas-1 do
        begin
            if FormSelImprime.lb_pranchas.Selected[i] then
              with projeto.pranchas[i] do
                begin
                    criaPranchaGraf (pranchaImprime, titulo, nFigx, nfigy, cor,
                                     itens, panel1);
                    application.processMessages;

                    bmp := FormImprime.GetFormImage;
                    Printer.Canvas.StretchDraw(
                        Rect(Round(HDPI * 0.3), Round(HDPI * 0.35), x, y), bmp);
                    bmp.Free;

                    tit := 'Prancha Fcil - ' + titulo + ' - ' + DateToStr(date);
                    printer.canvas.TextOut(Round(HDPI * 0.3),
                                           printer.pageHeight-80, tit);

                    sleep (300);   // s para o usurio dar uma olhadinha
                    destroiPranchaGraf(pranchaImprime);

                    if i <> ultSel then
                        printer.Newpage;
                end;
        end;

    printer.EndDoc;
    Screen.Cursor := crDefault;

    close;
end;

end.

