{---------------------------------------------------------------}
{
{    PRANCHA FCIL - Editor e Apresentador de
{                    Pranchas para Comunicao Alternativa
{
{    Mdulo de programao das pranchas
{
{    Autores: Jos Antonio Borges     (NCE/UFRJ)
{             Miryam Bonadiu Pelosi    (LabAssistiva/UFRJ)
{             Julio Tadeu da Silveira  (NCE/UFRJ)
{
{    Verso 1.1 em abril/2015
{
{----------------------------------------------------------------}

unit prProg;

interface

uses
  Consts,     // verso customizada para portugus
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, ExtCtrls, jpeg, ComCtrls, Buttons, shellApi;

type
  TFormProg = class(TForm)
    MainMenu1: TMainMenu;
    lb_pranchas: TListBox;
    Label1: TLabel;
    Configuraogeral1: TMenuItem;
    lb_itens: TListBox;
    Label9: TLabel;
    Label10: TLabel;
    b_remover: TButton;
    b_paraCima: TButton;
    b_paraBaixo: TButton;
    b_detalhar: TButton;
    b_removerItem: TButton;
    b_paraCimaItem: TButton;
    b_paraBaixoItem: TButton;
    b_detalharItem: TButton;
    b_insAbaixo: TButton;
    b_insAbaixoItem: TButton;
    p_previewPrancha: TPanel;
    Visualizar1: TMenuItem;
    b_duplicar: TButton;
    b_duplicarItem: TButton;
    SpeedPanel: TPanel;
    SaveBtn: TSpeedButton;
    VisuBtn: TSpeedButton;
    PrintBtn: TSpeedButton;
    ConfigBtn: TSpeedButton;
    jpgButton: TSpeedButton;
    Arquivo1: TMenuItem;
    Salvar2: TMenuItem;
    ImprimirPrancha2: TMenuItem;
    GerarJPG1: TMenuItem;
    Terminar1: TMenuItem;
    b_sair1: TSpeedButton;
    Autoria1: TMenuItem;
    ConfigExec1: TMenuItem;
    aJuda1: TMenuItem;
    ajudaButton1: TSpeedButton;
    procedure b_detalharItemClick(Sender: TObject);
    procedure b_detalharClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure lb_pranchasKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lb_pranchasClick(Sender: TObject);
    procedure b_removerClick(Sender: TObject);
    procedure b_paraCimaClick(Sender: TObject);
    procedure b_paraBaixoClick(Sender: TObject);
    procedure b_insAbaixoClick(Sender: TObject);
    procedure lb_pranchasDblClick(Sender: TObject);
    procedure lb_itensDblClick(Sender: TObject);
    procedure b_removerItemClick(Sender: TObject);
    procedure b_paraCimaItemClick(Sender: TObject);
    procedure b_paraBaixoItemClick(Sender: TObject);
    procedure b_InsAcimaItemClick(Sender: TObject);
    procedure b_insAbaixoItemClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Visualizar1Click(Sender: TObject);
    procedure Salvar1Click(Sender: TObject);
    procedure p_previewPranchaClick(Sender: TObject);
    procedure Imprimirprancha1Click(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure ConfigBtnClick(Sender: TObject);
    procedure VisuBtnClick(Sender: TObject);
    procedure PrintBtnClick(Sender: TObject);
    procedure b_duplicarClick(Sender: TObject);
    procedure b_duplicarItemClick(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure jpgButtonClick(Sender: TObject);
    procedure PranchaemJPEG1Click(Sender: TObject);
    procedure Terminar1Click(Sender: TObject);
    procedure b_sair1Click(Sender: TObject);
    procedure ConfigExec1Click(Sender: TObject);
    procedure aJuda1Click(Sender: TObject);
    procedure Autoria1Click(Sender: TObject);
  private
    { Private declarations }
    pranchasAlocadas: TList;
    procedure LigaDesligaBotoes;
    procedure carregaFormProg;
    function b_insClick(Sender: TObject; abaixo: boolean): boolean;
    function b_insItemClick(Sender: TObject; abaixo: boolean): boolean;
    procedure desenhaPrancha (ind: integer);
  public
    { Public declarations }
  end;

var
  FormProg: TFormProg;

implementation

uses prVars, prConfigPrancha, prConfigItem, prConfigExec, prGraficos,
    prArq, prVisualiza, prAutoria;

{$R *.dfm}

var
    pranchaPreview: TPranchaGraf;

procedure TFormProg.LigaDesligaBotoes;
begin
    if lb_pranchas.Count = 0 then
        begin
            b_insAbaixo.Enabled := true;
            b_duplicar.Enabled := false;
            b_detalhar.Enabled := false;
            b_paraCima.Enabled := false;
            b_paraBaixo.Enabled := false;
            b_remover.Enabled := false;
        end
    else
        begin
            b_insAbaixo.Enabled := true;
            b_duplicar.Enabled := true;
            b_detalhar.Enabled := true;
            b_paraCima.Enabled := true;
            b_paraBaixo.Enabled := true;
            b_remover.Enabled := true;
        end;

    if lb_itens.Count = 0 then
        begin
            b_insAbaixoItem.Enabled := true;
            b_duplicarItem.Enabled := false;
            b_detalharItem.Enabled := false;
            b_paraCimaItem.Enabled := false;
            b_paraBaixoItem.Enabled := false;
            b_removerItem.Enabled := false;
        end
    else
        begin
            if lb_pranchas.itemIndex < 0 then
                b_insAbaixoItem.Enabled := false
            else
                b_insAbaixoItem.Enabled := true;
            b_duplicarItem.Enabled := true;
            b_detalharItem.Enabled := true;
            b_paraCimaItem.Enabled := true;
            b_paraBaixoItem.Enabled := true;
            b_removerItem.Enabled := true;
        end;
end;

procedure TFormProg.FormCreate(Sender: TObject);
begin
    pranchasAlocadas := TList.Create;
end;

procedure TFormProg.b_detalharClick(Sender: TObject);
begin
    if lb_pranchas.ItemIndex < 0 then exit;
    formConfigPrancha.setInfo(lb_pranchas.ItemIndex);
    formConfigPrancha.showModal;
    formConfigPrancha.getInfo(lb_pranchas.ItemIndex);
    desenhaPrancha (lb_pranchas.Itemindex);

    if projeto.nPranchas > 0 then
        lb_pranchas.Items[lb_pranchas.ItemIndex] :=
                  projeto.pranchas[lb_pranchas.ItemIndex].nome;
end;

procedure TformProg.desenhaPrancha (ind: integer);
begin
    if ind >= 0 then
        begin
            with projeto.pranchas[ind] do
                criaPranchaGraf (pranchaPreview, titulo, nfigx, nfigy, cor,
                                 projeto.pranchas[ind].itens,
                                 p_previewPrancha);
        end;

    LigaDesligaBotoes;
end;

procedure TFormProg.FormActivate(Sender: TObject);
begin
    carregaFormProg;
    lb_pranchasClick(Sender);
end;

procedure TFormProg.carregaFormProg;
var p, i: integer;
begin
    lb_pranchas.Items.Clear;
    lb_itens.Items.Clear;
    with projeto do
        begin
            for p := 0 to projeto.nPranchas-1 do
                lb_pranchas.Items.Add(pranchas[p].nome);
            if projeto.nPranchas > 0 then
                begin
                    lb_pranchas.ItemIndex := 0;
                    for i := 0 to pranchas[0].nitens-1 do
                        lb_itens.Items.Add(pranchas[0].itens[i].rotulo);
                end;
        end;
end;

procedure TFormProg.lb_pranchasKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  lb_pranchasClick(Sender);
end;

procedure TFormProg.lb_pranchasClick(Sender: TObject);
var p, i: integer;
begin
    with projeto do
        begin
            p := lb_pranchas.ItemIndex;
            if p >= 0 then
                begin
                    lb_itens.Clear;
                    for i := 0 to pranchas[p].nitens-1 do
                        lb_itens.Items.Add(pranchas[p].itens[i].rotulo);
                end;
        end;

    desenhaPrancha(lb_pranchas.ItemIndex);
end;

procedure TFormProg.b_removerClick(Sender: TObject);
var p, p2: integer;
begin
    p := lb_pranchas.ItemIndex;
    if p < 0 then exit;

    if MessageDlg('Quer mesmo remover?', mtConfirmation,
         [mbYes, mbNo], 0) <> mrYes then exit;

    with projeto do
        begin
            SetLength (pranchas[p].itens, 0);
            for p2 := p to nPranchas-2 do
                pranchas[p2] := pranchas [p2+1];
            SetLength (pranchas[npranchas-1].itens, 0);
            npranchas := npranchas - 1;
            lb_pranchas.Items.Delete(p);
            lb_pranchas.ItemIndex := p;
            lb_pranchasClick(Sender);

            if lb_pranchas.Count = 0 then
                begin
                    lb_itens.Clear;
                    destroiPranchaGraf(pranchaPreview);
                end;
        end;
end;

procedure TFormProg.b_paraCimaClick(Sender: TObject);
var p: integer;
    temp: TPrancha;
begin
    p := lb_pranchas.ItemIndex;
    if p < 1 then exit;

    with projeto, lb_pranchas do
        begin
            temp := pranchas[itemIndex-1];
            pranchas[p-1] := pranchas[p];
            pranchas[p] := temp;
            Items.Move(p, p-1);
            itemIndex := p-1;
        end;
end;

procedure TFormProg.b_paraBaixoClick(Sender: TObject);
var p: integer;
    temp: TPrancha;
begin
    p := lb_pranchas.ItemIndex;
    if p > projeto.npranchas-2 then exit;

    with projeto, lb_pranchas do
        begin
            temp := pranchas[itemIndex+1];
            pranchas[p+1] := pranchas[p];
            pranchas[p] := temp;
            Items.Move(p, p+1);
            itemIndex := p+1;
        end;
end;

procedure criaPrancha (p: integer; novoNome: string);
begin
    with projeto.pranchas[p] do
        begin
           nome := NovoNome;
           titulo := NovoNome;
           nFigx := 3;
           nFigy := 3;
           linkDefault := '';
           cor := clWhite;
           som := '';
           fala := '';
           nitens:= 0;
           setLength(itens, 0);
        end;
end;

function TFormProg.b_insClick(Sender: TObject; abaixo: boolean): boolean;
var p, n: integer;
    NovoNome: string;
begin
    result := false;
    NovoNome := 'Nova prancha';
    if not InputQuery('Informe o nome desta prancha',
               'No repita nomes, ou pode ter problemas depois', NovoNome) then
        exit;

    p := lb_pranchas.ItemIndex;
    if (lb_pranchas.count = 0) or abaixo then p := p + 1;

    lb_pranchas.Items.Add(NovoNome);
    lb_pranchas.Items.Move(lb_pranchas.count-1, p);

    with projeto do
        begin
            inc(npranchas);
            setLength (pranchas, npranchas);
            for n := nPranchas-2 downto p do
                pranchas[n+1] := pranchas[n];

            criaPrancha(p, NovoNome);
        end;

    lb_pranchas.ItemIndex := p;
    lb_pranchasClick(sender);
    result := true;
end;

procedure TFormProg.b_insAbaixoClick(Sender: TObject);
begin
    if b_insClick(Sender, true) then
        b_detalharClick(Sender);
end;

procedure TFormProg.b_detalharItemClick(Sender: TObject);
var p, i, n: integer;
begin
    p := lb_pranchas.ItemIndex;
    i := lb_itens.ItemIndex;
    if (p < 0) or (i < 0) then exit;

    formConfigItem.setInfo(p, i);
    formConfigItem.showModal;
    formConfigItem.getInfo(p, i);

    lb_itens.Clear;
    with projeto do
        for n := 0 to pranchas[p].nitens-1 do
             lb_itens.items.add(pranchas[p].itens[n].rotulo);
    lb_itens.ItemIndex := i;

    desenhaPrancha (lb_pranchas.Itemindex);
end;


procedure TFormProg.lb_pranchasDblClick(Sender: TObject);
begin
    b_detalharClick(Sender);
end;

procedure TFormProg.lb_itensDblClick(Sender: TObject);
begin
    b_detalharItemClick(Sender);
end;

procedure TFormProg.b_removerItemClick(Sender: TObject);
var p, ppr, p2: integer;
begin
    ppr := lb_pranchas.ItemIndex;
    p := lb_itens.ItemIndex;
    if ppr < 0 then exit;
    if p < 0 then exit;

    if MessageDlg('Quer mesmo remover?', mtConfirmation,
         [mbYes, mbNo], 0) <> mrYes then exit;

    with projeto.pranchas[ppr] do
        begin
            lb_itens.Items.delete(p);
            for p2 := p to nitens-2 do
                itens[p2] := itens[p2+1];
            nitens := nitens - 1;
            SetLength (itens, nitens);
            lb_itens.ItemIndex := p;
        end;

    desenhaPrancha (lb_pranchas.Itemindex);
end;

procedure TFormProg.b_paraCimaItemClick(Sender: TObject);
var p, ppr: integer;
    temp: TItem;
begin
    ppr := lb_pranchas.ItemIndex;
    if ppr < 0 then exit;
    p := lb_itens.ItemIndex;
    if p < 1 then exit;

    with projeto.pranchas[ppr], lb_itens do
        begin
            temp := itens[itemIndex-1];
            itens[p-1] := itens[p];
            itens[p] := temp;
            Items.Move(p, p-1);
            itemIndex := p-1;
        end;

    desenhaPrancha (lb_pranchas.Itemindex);
end;

procedure TFormProg.b_paraBaixoItemClick(Sender: TObject);
var p, ppr: integer;
    temp: TItem;
begin
    ppr := lb_pranchas.ItemIndex;
    if ppr < 0 then exit;
    p := lb_itens.ItemIndex;
    if p > projeto.pranchas[ppr].nitens-2 then exit;

    with projeto.pranchas[ppr], lb_itens do
        begin
            temp := itens[itemIndex+1];
            itens[p+1] := itens[p];
            itens[p] := temp;
            Items.Move(p, p+1);
            itemIndex := p+1;
        end;

    desenhaPrancha (lb_pranchas.Itemindex);
end;

procedure criaItem (ppr, p: integer; novoNome: string);
begin
    with projeto.pranchas[ppr] do
        begin
           itens[p].rotulo := NovoNome;
           itens[p].figura := '';
           itens[p].posTexto := baixo;
           itens[p].dimTexto := TEXTO_PEQUENO;
           itens[p].link := '';
           itens[p].cor := clWhite;
           itens[p].som := '';
           itens[p].fala := '';
           itens[p].executar := '';
        end;
end;

function TFormProg.b_insItemClick(Sender: TObject; abaixo: boolean): boolean;
var p, ppr, n: integer;
    NovoNome: string;
begin
    result := false;
    ppr := lb_pranchas.ItemIndex;
    if ppr < 0 then exit;
    p := lb_itens.ItemIndex;
    if (lb_pranchas.count = 0) or abaixo then p := p + 1;
    if p < 0 then p := 0;

    NovoNome := 'Novo item';
    if not InputQuery('Insero de novo item', 'Informe o nome deste item', NovoNome) then
        exit;

    lb_itens.Items.Add(NovoNome);
    lb_itens.Items.Move(lb_itens.count-1, p);

    with projeto.pranchas[ppr] do
        begin
            inc(nitens);
            setLength (itens, nitens);
            for n := nitens-2 downto p do
                itens[n+1] := itens[n];

            criaItem(ppr, p, NovoNome);
        end;

    lb_itens.ItemIndex := p;
    result := true;
end;

procedure TFormProg.b_InsAcimaItemClick(Sender: TObject);
begin
    if b_insItemClick(Sender, false) then
        b_detalharItemClick(Sender);
end;

procedure TFormProg.b_insAbaixoItemClick(Sender: TObject);
begin
    if b_insItemClick(Sender, true) then
        b_detalharItemClick(Sender);
end;

procedure TFormProg.Visualizar1Click(Sender: TObject);
begin
    if lb_pranchas.itemIndex < 0 then exit;
    formVisualiza.selPrancha (lb_pranchas.ItemIndex);
    formVisualiza.ShowModal;
end;

procedure TFormProg.Salvar1Click(Sender: TObject);
begin
    renameFile (dirProjeto + '\pranchas.pra', dirProjeto + '\pranchas.bak');
    salvaPranchas(dirProjeto, 'pranchas.pra');
end;

procedure TFormProg.p_previewPranchaClick(Sender: TObject);
begin
    if projeto.nPranchas <> 0 then
        Visualizar1Click(sender);
end;

procedure TFormProg.Imprimirprancha1Click(Sender: TObject);
begin
    formVisualiza.selPrancha (lb_pranchas.ItemIndex);
    formVisualiza.Show;
    application.ProcessMessages;
    formVisualiza.Imprime;
    application.ProcessMessages;
    formVisualiza.Close;
end;

procedure TFormProg.SaveBtnClick(Sender: TObject);
begin
    Salvar1Click(Sender);
end;

procedure TFormProg.ConfigExec1Click(Sender: TObject);
begin
    FormConfigExec.Show;
end;

procedure TFormProg.ConfigBtnClick(Sender: TObject);
begin
    ConfigExec1Click (Sender);
end;

procedure TFormProg.VisuBtnClick(Sender: TObject);
begin
    Visualizar1Click(Sender);
end;

procedure TFormProg.PrintBtnClick(Sender: TObject);
begin
    Imprimirprancha1Click(Sender);
end;

procedure TFormProg.b_duplicarClick(Sender: TObject);
var n: integer;
    ppr, ppant: integer;
    itemDest, itemAnt: ^TItem;
begin
    if lb_pranchas.ItemIndex < 0 then
        begin
            showMessage ('No h nenhuma prancha selecionada');
            exit;
        end;

    b_insClick(Sender, true);

    ppant := lb_pranchas.ItemIndex-1;
    ppr := lb_pranchas.ItemIndex;
    with projeto.pranchas[ppr] do
        begin
            nFigx       := projeto.pranchas[ppant].nFigx;
            nFigy       := projeto.pranchas[ppant].nFigy;
            cor         := projeto.pranchas[ppant].cor;
            som         := projeto.pranchas[ppant].som;
            linkDefault := projeto.pranchas[ppant].linkDefault;
            fala        := projeto.pranchas[ppant].fala;
            nitens      := projeto.pranchas[ppant].nitens;

            setLength (itens, nitens);
            for n := 0 to nitens-1 do
                begin
                    itemDest := @projeto.pranchas[ppr].itens[n];
                    itemAnt  := @projeto.pranchas[ppant].itens[n];

                    itemDest^.rotulo      := itemAnt^.rotulo;
                    itemDest^.semRotulo   := itemAnt^.semRotulo;
                    itemDest^.figura      := itemAnt^.figura;
                    itemDest^.semFigura   := itemAnt^.semFigura;
                    itemDest^.cor         := itemAnt^.cor;
                    itemDest^.som         := itemAnt^.som;
                    itemDest^.link        := itemAnt^.link;
                    itemDest^.fala        := itemAnt^.fala;
                    itemDest^.executar    := itemAnt^.executar;
                    itemDest^.posTexto    := itemAnt^.posTexto;
                    itemDest^.dimTexto    := itemAnt^.dimTexto;
                    itemDest^.dimMoldura  := itemAnt^.dimMoldura;
                    itemDest^.deslocHoriz := itemAnt^.deslocHoriz;
                end;
        end;

    lb_itens.ItemIndex := 0;
    desenhaPrancha (lb_pranchas.Itemindex);
    lb_pranchasClick(Sender);
end;

procedure TFormProg.b_duplicarItemClick(Sender: TObject);
var
    pr, iatu, iant: integer;
    itemDest, itemAnt: ^TItem;
begin
    if lb_itens.ItemIndex < 0 then
        begin
            showMessage ('No h nenhum item selecionado');
            exit;
        end;

    b_insItemClick(Sender, true);

    pr := lb_pranchas.itemIndex;
    iant := lb_itens.ItemIndex-1;
    iatu := lb_itens.ItemIndex;

    itemDest := @projeto.pranchas[pr].itens[iatu];
    itemAnt  := @projeto.pranchas[pr].itens[iant];

    if itemAnt^.figura = '' then
        itemDest^.figura      := itemAnt^.rotulo
    else
        itemDest^.figura      := itemAnt^.figura;

    itemDest^.semRotulo   := itemAnt^.semRotulo;
    itemDest^.semFigura   := itemAnt^.semFigura;
    itemDest^.cor         := itemAnt^.cor;
    itemDest^.som         := itemAnt^.som;
    itemDest^.link        := itemAnt^.link;
    itemDest^.fala        := itemAnt^.fala;
    itemDest^.executar    := itemAnt^.executar;
    itemDest^.posTexto    := itemAnt^.posTexto;
    itemDest^.dimTexto    := itemAnt^.dimTexto;
    itemDest^.dimMoldura  := itemAnt^.dimMoldura;
    itemDest^.deslocHoriz := itemAnt^.deslocHoriz;

    desenhaPrancha (lb_pranchas.Itemindex);
end;

procedure TFormProg.FormDeactivate(Sender: TObject);
begin
   destroiPranchaGraf(pranchaPreview);
end;

procedure TFormProg.jpgButtonClick(Sender: TObject);
begin
    PranchaemJPEG1Click(Sender);
end;

procedure TFormProg.PranchaemJPEG1Click(Sender: TObject);
begin
    formVisualiza.selPrancha (lb_pranchas.ItemIndex);
    somInibido := true;
    formVisualiza.Show;
    application.ProcessMessages;
    formVisualiza.GeraJPG;
    application.ProcessMessages;
    formVisualiza.Close;
    somInibido := false;
end;

procedure TFormProg.Terminar1Click(Sender: TObject);
begin
    carregaPranchas(dirProjeto);
    close;
end;

procedure TFormProg.b_sair1Click(Sender: TObject);
begin
    Salvar1Click(Sender);
    Terminar1Click(Sender);
end;

procedure TFormProg.aJuda1Click(Sender: TObject);
var Path: string;
begin
    Path := ExtractFilePath(Application.ExeName);
    if fileExists (Path + 'pranchaFacil.chm') then
        shellExecute (handle, 'OPEN', pchar(Path + 'pranchaFacil.chm'), NIL, '.', SW_SHOW)
    else
        messageDlg ('Arquivo de ajuda no encontrado', mtError, [mbok], 0);
end;

procedure TFormProg.Autoria1Click(Sender: TObject);
begin
    formAutoria.showModal;
end;

end.
