{---------------------------------------------------------------}
{
{    PRANCHA FCIL - Editor e Apresentador de
{                    Pranchas para Comunicao Alternativa
{
{    Mdulo de seleo de figuras
{
{    Autores: Jos Antonio Borges     (NCE/UFRJ)
{             Miryam Bonadiu Pelosi    (LabAssistiva/UFRJ)
{             Julio Tadeu da Silveira  (NCE/UFRJ)
{
{    Verso 1.1 em abril/2015
{
{----------------------------------------------------------------}

unit prSelFigura;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, jpeg, shellapi;

type
  TformSelFigura = class(TForm)
    Label1: TLabel;
    e_iniciais: TEdit;
    l_arquivos: TListBox;
    b_ok: TButton;
    b_cancela: TButton;
    Image1: TImage;
    b_verTodas: TButton;
    e_novoNome: TEdit;
    procedure b_okClick(Sender: TObject);
    procedure b_cancelaClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure e_iniciaisChange(Sender: TObject);
    procedure l_arquivosDblClick(Sender: TObject);
    procedure l_arquivosClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure b_verTodasClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formSelFigura: TformSelFigura;
  figuraImportada: string;

implementation

uses prvars;

var listaFigs: TStringList;
    dirArasaac: string;

{$R *.dfm}

procedure TformSelFigura.FormCreate(Sender: TObject);
var sr: TSearchRec;
    nomeArq: string;
begin
    getDir (0, dirArasaac);
    dirArasaac := dirArasaac + '\ARASAAC_mini';

    listaFigs := TStringList.Create;
    if findFirst (dirArasaac + '\*.*', faAnyFile, sr) = 0 then
        repeat
            nomeArq := sr.FindData.cFileName;
            if upperCase (copy (nomeArq, length(nomeArq)-3, 4)) = '.JPG' then
                listaFigs.Add(copy (nomeArq, 1, length(nomeArq)-4));
        until findNext (sr) <> 0;
    FindClose(sr);
end;

procedure TformSelFigura.e_iniciaisChange(Sender: TObject);
var tx, titulo, nomeArq: string;
    i: integer;
begin
    l_arquivos.Clear;
    tx := ansiUpperCase(trim(e_iniciais.text));
    if length(tx) = 0 then exit;

    for i := 1 to listaFigs.count-1 do
        begin
            titulo := ansiUpperCase(listaFigs[i]);

            if ((length(tx) = 1) and (tx = titulo))   or
               ((length(tx) > 1) and (copy(titulo, 1, length(tx)) = tx)) then
                begin
                    nomeArq := listaFigs[i];
                    l_arquivos.items.add (listaFigs[i]);
                end;
        end;
end;

procedure TformSelFigura.b_okClick(Sender: TObject);
begin
    if l_arquivos.ItemIndex < 0 then
        b_cancelaClick(Sender)
    else
        begin
            figuraImportada := e_novoNome.Text;
            if FileExists(figuraImportada) then
                begin
                    if MessageDlg('Uma figura com este nome j existe.  Posso substituir?',
                                  mtWarning, [mbYes,mbAll], 0) = mrYes then
                        DeleteFile(figuraImportada)
                    else
                        exit;
                end;
            CopyFile(PChar(dirArasaac + '\' + figuraImportada),
                     PChar(figuraImportada), False);
        end;
    close;
end;

procedure TformSelFigura.b_cancelaClick(Sender: TObject);
begin
    figuraImportada := '';
    close;
end;

procedure TformSelFigura.l_arquivosDblClick(Sender: TObject);
begin
    b_OKClick(sender);
end;

procedure ConverterJPegParaBmp(Arquivo: string);
var
  JPeg: TJPegImage;
  Bmp: TBitmap;
begin
  JPeg := TJPegImage.Create;
  try
    JPeg.LoadFromFile(Arquivo);
    Bmp := TBitmap.Create;
    try
      Bmp.Assign(JPeg);
      Bmp.SaveToFile('$$$.bmp');
    finally
      Bmp.Free;
    end;
  finally
    JPeg.Free;
  end;
end;

procedure TformSelFigura.l_arquivosClick(Sender: TObject);
begin
   ConverterJPegParaBmp(dirArasaac + '\'+l_arquivos.Items[l_arquivos.itemIndex]+'.jpg');
   image1.Picture.LoadFromFile('$$$.bmp');
   deleteFile ('$$$.bmp');
   e_novoNome.Text := l_arquivos.Items[l_arquivos.itemIndex] + '.jpg';
end;

procedure TformSelFigura.FormActivate(Sender: TObject);
begin
    image1.Picture.Bitmap.FreeImage;
end;

procedure TformSelFigura.b_verTodasClick(Sender: TObject);
begin
    shellExecute(0, 'open', pchar(dirArasaac), NIL, NIL, SW_MAXIMIZE);
end;

end.
