{---------------------------------------------------------------}
{
{    PRANCHA FCIL - Editor e Apresentador de
{                    Pranchas para Comunicao Alternativa
{
{    Mdulo de controle do sintetizador de voz
{
{    Autores: Jos Antonio Borges     (NCE/UFRJ)
{             Miryam Bonadiu Pelosi    (LabAssistiva/UFRJ)
{             Julio Tadeu da Silveira  (NCE/UFRJ)
{
{    Verso 1.1 em abril/2015
{
{----------------------------------------------------------------}

unit prSint;

interface
uses
    windows, Dialogs, speechLib_TLB, activex;

procedure sintAbre (adverteSeErro: boolean);
procedure sintFecha;
procedure sintFala(s: string);
procedure sintCala;
function sintAtivo: boolean;

var
    sintet: TSpVoice;

implementation

var
    //SOTokens: ISpeechObjectTokens;
    ev: THandle;

function sintAtivo: boolean;
begin
    if sintet = NIL then
        result := false
    else
        result := waitForSingleObject (ev, 20) = WAIT_TIMEOUT;
end;

procedure sintFala(s: string);
begin
    if sintet = NIL then exit;

    if pos (#$0a, s) <> 0 then delete (s, pos (#$0a, s), 9999);
    if s <> '' then
        try
            sintet.Speak(s, SVSFlagsAsync+SVSFIsNotXML);
        except end;
end;

procedure sintCala;
begin
    if sintet = NIL then exit;
    try
        sintet.Speak(' ', SVSFPurgeBeforeSpeak+SVSFDefault);
    except end;
end;

procedure sintAbre (adverteSeErro: boolean);
begin
    try
        sintet := TSpVoice.Create(NIL);
    except
        sintet := NIL;
        if adverteSeErro then
            showMessage ('Esta mquina no tem nenhum sintetizador de voz instalado.'+^m^j+
                         'A configurao de "Falas automticas" no ir funcionar.');
        exit;
    end;

    sintet.EventInterests := SVEEndInputStream;  // SVEAllEvents
    ev := sintet.SpeakCompleteEvent;
end;

procedure sintFecha;
begin
   if sintet <> NIL then
       begin
           try
               sintet.Speak('O', SVSFlagsAsync+SVSFIsNotXML);  // precisa falar algo para no travar
               sintet.Speak(' ', SVSFPurgeBeforeSpeak+SVSFDefault);
           except end;
           sintet.EventInterests := 0;
           ev := 0;
           sintet := NIL;
       end;
end;

end.

