{---------------------------------------------------------------}
{
{    PRANCHA FCIL - Editor e Apresentador de
{                    Pranchas para Comunicao Alternativa
{
{    Mdulo de variveis globais
{
{    Autores: Jos Antonio Borges     (NCE/UFRJ)
{             Miryam Bonadiu Pelosi    (LabAssistiva/UFRJ)
{             Julio Tadeu da Silveira  (NCE/UFRJ)
{
{    Verso 1.1 em abril/2015
{
{----------------------------------------------------------------}

unit prVars;

interface
uses graphics, classes, stdCtrls, extCtrls;

const
    versao = '1.2 beta';

    TEXTO_TITULO =  48;

    TEXTO_PEQUENO = 18;     // 8
    TEXTO_MEDIO   = 36;    // 13
    TEXTO_GRANDE  = 72;    // 18

    TAM_MIN_FONTE = 8;     // 8
    TAM_MAX_FONTE = 400;   // 25

type
    TPosVertical = (baixo, meio, cima);
    TDimMoldura = (sem, fina, media, grossa);

    TItem = record
        rotulo: string;
        semRotulo: boolean;
        figura: string;
        semFigura: boolean;
        cor: TColor;
        som: string;
        link: string;
        fala: string;
        executar: string;
        posTexto: TPosVertical;
        dimTexto: integer;
        dimMoldura: TDimMoldura;
        deslocHoriz: boolean;
    end;

    TItemGraf = record
        gpanel: TPanel;
        gimage: TImage;
        glabel: TLabel;
        gmoldura: TShape;
        alocado: boolean;
        invisivel: boolean;
    end;

    TItemArray = array of TItem;

    TPrancha = record
        nome: string;
        titulo: string;
        nFigx, nFigy: integer;
        cor: TColor;
        som: string;
        linkDefault: string;
        fala: string;
        nitens: integer;
        itens: TItemArray;
    end;

    TPranchaGraf = record
        gp_label: TLabel;
        gp_item: array of TItemGraf;
        alocada: boolean;
    end;

    TProjeto = record
        nome: string;
        autor: string;
        data: string;
        info: string;
        nPranchas: integer;
        pranchas: array of TPrancha;
        falaAutomatica: boolean;
        falaVarredura: boolean;
        SintetNaoGravados: boolean;
        acionaTobii: boolean;
        tempoVarredura:integer;
        tempoHisterese: integer;
        tempoSocorro: integer;
        tempoAutoClique: integer;
        pranchaInicial: string;
        pranchaSocorro: string;
    end;

var
    dirProjeto: string;
    projeto: TProjeto;
    pranchaEscolhida: string;

    somInibido: boolean;

implementation

end.
